using System.Collections.Generic;
using System.Threading.Tasks;
using gswi.Model;
using gswi.Share.Common;

namespace gswi.Interface.Repositories
{
    public interface IAuthUserRepository
    {
         Task<List<AuthUser>> GetAllAuthUsersAsync();
         Task<(List<AuthUser>, int totalCount)> GetFilteredAuthUsersAsync(AuthUserSelectCriterion selectCriterion);
         Task<AuthUser> GetAuthUserByEMailAsync(string email);
         Task<AuthUser> FindAuthUserByEMailAsync(string email);
         Task<AuthUser> FindAuthUserByEMailConfirmationIdAsync(string id);
         Task<AuthUser> FindAuthUserByEMailForgotPasswordIdAsync(string id);
         void AddAuthUser(AuthUser user);
         Task DeleteAuthUserByEMailAsync(string email);
         void DeleteAuthUser(AuthUser user);
    }
}