using System.Collections.Generic;
using System.Security.Cryptography;
using System.Threading.Tasks;
using gswi.Model.DTOs;
using gswi.Share.Common;

namespace gswi.Interface.Services {
    public interface IAuthService {
        Task<List<AuthUserDTO>> GetAllAuthUsersAsync();
        Task<GetFilteredAuthUsersResultDTO> GetFilteredAuthUsersAsync(AuthUserSelectCriterion selectCriterion);
        Task<AuthUserDTO> GetAuthUserByEMailAsync(string email);
        Task<AuthUserDTO> FindAuthUserByEMailAsync(string email);
        Task<long> AddAuthUserAsync(AuthUserDTO userDTO);
        Task<bool> ConfirmEMail(string id);
        Task<TokenDTO> Login(AuthUserDTO userDTO);
        Task ForgotPassword(string email);
        Task<EMailStringDTO> ConfirmForgotPassword(string id);
        Task ResetPassword(ResetPasswordDTO rpDTO);
        Task UpdateUser(UpdateUserDTO updateUserDTO);
        Task UpdateUserAsAdmin(AdminUpdateUserDTO updateUserDTO);
        Task<TokenDTO> Refresh(TokenDTO tokenDTO);
        Task Revoke(TokenDTO tokenDTO);
        Task DeleteAuthUserByEMailAsync(string email);
        Task DeleteAuthUserAsync(AuthUserDTO userDTO);
    }
}